#ifndef __INC_H__
#define __INC_H__

#include <glib.h>

#include "mainwindow.h"
#include "progressdialog.h"
#include "prefs_account.h"

typedef struct _Pop3State	Pop3State;

typedef enum {
	POP3_GREETING_RECV,
	POP3_GETAUTH_USER_SEND,
	POP3_GETAUTH_USER_RECV,
	POP3_GETAUTH_PASS_SEND,
	POP3_GETAUTH_PASS_RECV,
	POP3_GETAUTH_APOP_SEND,
	POP3_GETAUTH_APOP_RECV,
	POP3_GETRANGE_STAT_SEND,
	POP3_GETRANGE_STAT_RECV,
	POP3_GETRANGE_LAST_SEND,
	POP3_GETRANGE_LAST_RECV,
	POP3_RETR_SEND,
	POP3_RETR_RECV,
	POP3_DELETE_SEND,
	POP3_DELETE_RECV,
	POP3_LOGOUT_SEND,
	POP3_LOGOUT_RECV
} Pop3Phase;

#define N_POP3_PHASE	17

struct _Pop3State
{
	ProgressDialog *progress;
	gboolean cancelled;
	PrefsAccount *ac_prefs;
	GHashTable *folder_table;

	MainWindow *mainwin;

	gchar *prev_folder;
	gint msgnum;

	gint sock;

	gchar *greeting;
	gchar *user;
	gchar *pass;
	gint count;
	gint new;
	gint bytes;
	gint cur_msg;
};

void inc_mail			(MainWindow	*mainwin);
void inc_all_account_mail	(MainWindow	*mainwin);
void inc_progress_update	(Pop3State	*state,
				 Pop3Phase	 phase);
gint inc_drop_message		(const gchar	*file,
				 Pop3State	*state);

#endif /* __INC_H__ */
